<script lang="ts">
	import { onMount, setContext } from "svelte";
	import { Download } from "../download";
	import {
		activeDownloadStore,
		settingsStore,
		wsMessageStore,
	} from "../stores";
	import type { WebSocketMessage } from "../websocket";
	import { WebSocketWrapper } from "../websocket";
	import AddDownload from "./AddDownload.svelte";
	import Downloads from "./Downloads.svelte";
	import Settings from "./Settings.svelte";

	// @ts-ignore
	const apiUrl = __myapp.env.API_URL;

	// Fetch the settings on mount and update the settings store
	onMount(async () => {
		const res = await fetch(`//${apiUrl}/settings`);
		const settings = await res.json();
		settingsStore.set(settings);
	});

	// startUpdate starts querying the websocket for download progress updates
	let updateIntervalId;
	const startUpdate = () => {
		updateIntervalId = setInterval(() => {
			webSocket.send({
				action: "update",
			});
		}, 1000);
	};

	// Open the WebSocket connection
	let webSocket = new WebSocketWrapper({
		onOpen: () => {
			// Immediately start querying for download progress updates
			startUpdate();
		},
	});
	webSocket.open();

	// stopUpdate stops querying for download progress updates
	const stopUpdate = () => {
		clearInterval(updateIntervalId);
	};

	// Subscribe to the wsMessageStore to receive messages from the WebSocket
	wsMessageStore.subscribe((message: WebSocketMessage) => {
		if (message.action === "update") {
			// If there are active downloads in the message
			if (Array.isArray(message.data.active_downloads)) {
				// Parse the active downloads
				for (let ad of message.data.active_downloads) {
					// Check if the download is in the active downloads list
					let d = $activeDownloadStore.get(ad.url);

					if (!d) {
						// If not, create a new download
						d = new Download(ad.url);
					}

					// Set download progress
					d.setProgress(
						ad.filename,
						ad.size,
						ad.bytesComplete,
						ad.progress,
						ad.bytesPerSecond,
						ad.ellapsed,
						ad.eta,
						ad.done,
						ad.paused
					);
					activeDownloadStore.edit(ad.url, d);
				}
			} else {
				// Stop updating if there are no active downloads
				//stopUpdate();
				activeDownloadStore.clear();
			}
		}
	});

	// handleDownloadAdded handles the downloadAdded event from the AddDownload component
	function handleDownloadAdded(event) {
		if (event.detail) {
			// If the event is a mustUpdate, starting querying for download progress updates
			startUpdate();
		}
	}

	// Create a shared context with user action events
	setContext("actionEvents", {
		handlePause: (url) => {
			webSocket.send({
				action: "pause",
				data: url,
			});
		},
		handleResume: (url) => {
			webSocket.send({
				action: "resume",
				data: url,
			});
		},
		handleCancel: (url) => {
			activeDownloadStore.remove(url);
			webSocket.send({
				action: "cancel",
				data: url,
			});
		},
		handleCancelAndDelete: (url) => {
			activeDownloadStore.remove(url);
			webSocket.send({
				action: "cancel_delete",
				data: url,
			});
		},
		handleRemove: (url) => {
			activeDownloadStore.remove(url);
			webSocket.send({
				action: "remove",
				data: url,
			});
		},
		handleRemoveAndDelete: (url) => {
			activeDownloadStore.remove(url);
			webSocket.send({
				action: "remove_delete",
				data: url,
			});
		},
	});
</script>

<main class="p-5">
	<AddDownload on:downloadAdded={handleDownloadAdded} />
	<Downloads />
	<Settings />
</main>
